#include <string>
using namespace std;

#include <boost/assign/list_of.hpp> 
using namespace boost::assign; 
using namespace boost;

#include "conversationtree.hpp"

list< list <string> > weatherdescriptions;
list< list <string> > traumadescriptions;
list< list <Conv> >	  conversationtree;

list <string> selectedtrauma;
list <string> selectedweather;
list <Conv> selectedconv;

unsigned int maxscore;

unsigned int minleven(const string& w, string& r)
{
	unsigned int curmin=10000;
	
	list<string>::iterator it;
	for (it=selectedtrauma.begin();it!=selectedtrauma.end();it++)
	{
		if (levenshteindistance(w,*it)<curmin)
		{
			curmin=levenshteindistance(w,*it);
			r=*it;
		}
	}
	
	return curmin;
}

void calcmaxscore()
{
	unsigned int curcand=10000;
	string s;//not used
	
	list<string>::iterator it;
	for (it=selectedweather.begin();it!=selectedweather.end();it++)
	{
		curcand=min(curcand,minleven(*it,s));
	}
	maxscore=curcand;//actually the smallest?!?!
}

string traumafilter(string s, unsigned int turn)
{
	vector<string> words = parsestring(s);
	
	for (unsigned int i=0;i<words.size();i++)
	{
		if (isword(words[i]))
		{
			string replaceword;
			unsigned int score = minleven(words[i],replaceword);
			if (((turn>=(rand()%8))&&(turn>=(rand()%8))&&(turn>=(rand()%8)) ) || ((turn>=(rand()%8))&&(turn>=(rand()%8))&&(turn>=(rand()%8))&& (rand()%(score-maxscore+1)==0)))
			{
				words[i]=replaceword;
			}
				
		}
	}
	
	return reconstitute(words);
}

void chooseconv(unsigned int i)
{
	list<Conv>::iterator it=selectedconv.begin();
	
	for (unsigned int j=0;j<i;j++)
		it++;
	
	selectedconv.splice(selectedconv.end(),it->consequents);
	selectedconv.erase(it);
//	calcmaxscore();
}


void insertbasicdata()
{
	list<Conv> noconv;
	
	weatherdescriptions=list_of
								(list_of
								 ((string)"I remember the trees outside; how they swayed and shook as the ground trembled. ")
								 ((string)"Afterwards, I went outside, to find the roads buckled, the bridges collapsed. ")
								 ((string)"I rushed to look for my pet dog, jeff; I found him trapped beneath a wire fence, whimpering. ")
								 ((string)"My neighbour had a gun then; he was a violent man. ")
								 ((string)"He fired a shot right into his skull. ")
								 ((string)"My poor dog, jeff. ")
								)
								(list_of
								 ((string)"the air outside is so cool today. ")
								 ((string)"the wind was blowing so gently. ")
								 ((string)"it hasn't rained in so long. ")
								 ((string)"the water has all dried up. ")
								 ((string)"i can't even water my garden any more. ")
								 ((string)"my lawn is drying out, the grass has withered. ")
								 ((string)"i don't think there's any point in reseeding it this year. ")
								 ((string)"not until the rain begins to fall again. ")
								)
								(list_of
								 ((string)"i can still feel the warmth of the sun. ")
								 ((string)"it is glorious, but i prefer the shade. ")
								 ((string)"i can breath in the shade. ")
								 ((string)"i do not like sunbathing. ")
								 ((string)"i burn so very easily. ")
								 ((string)"that's why i stay indoors now. ")
								 )
								(list_of
								 ((string)"i can't remember where i left my keys. ")
								 ((string)"they're not in my pockets. ")
								 ((string)"did i leave them by the refridgerator. ")
								 ((string)"or maybe by the counter. ")
								 ((string)"maybe i left them on the bedroom table? ")
								 ((string)"i can't even remember if I drove here. ")
								 ((string)"i haven't driven in years. ")
								 )
								(list_of
								 ((string)"i have to go to the shops later. ")
								 ((string)"there are bills to be paid by the end of the week. ")
								 ((string)"i have to do some errands for my friends. ")
								 ((string)"and my family, they can be so demanding. ")
								 ((string)"i never have any time to myself. ")
								 ((string)"except when i go to bed at night. ")
								 ((string)"when my spouse refuses to sleep by my side. ")
								 ((string)"and leaves me alone. ")
								 )
								(list_of
								 ((string)"it started snowing outside this morning. ")
								 ((string)"i dashed to the window when i noticed. ")
								 ((string)"i pulled the curtains back. ")
								 ((string)"and outside all was blanketed in white. ")
								 ((string)"i could see animal tracks outside, in the street. ")
								 ((string)"i wondered if they were cold. ")
								 ((string)"if they would survive. ")
								 ((string)"if they would survive 'til summer. ")
								 )
								;
	
	traumadescriptions=list_of
								(list_of
									((string)"fat")((string)"man")((string)"violent")((string)"stranger")((string)"menace")
								)
								(list_of
									((string)"violent")((string)"husband")((string)"man")((string)"strike")((string)"defenceless")
								)
								(list_of
									((string)"cooling")((string)"sunlit")((string)"honey")((string)"gleam")((string)"standing")
								)
	(list_of
	 ((string)"wretch")((string)"shame")((string)"dishonest")((string)"lies")((string)"deceit")((string)"anger")
	 )	
	(list_of
	 ((string)"wealthy")((string)"fame")((string)"star")((string)"power")((string)"anger")
	 )
	(list_of
	 ((string)"teamwork")((string)"cooperation")((string)"management")((string)"strategy")((string)"mentoring")((string)"empowering")
	 )
	(list_of
	 ((string)"heterocentric")((string)"phallic")((string)"labial")((string)"oppression")((string)"patriarchy")((string)"discrimination")
	 )	
	(list_of
	 ((string)"body")((string)"dirty")((string)"rape")((string)"other")
	 )	
	(list_of
	 ((string)"handsome")((string)"lovely")((string)"dashing")((string)"love")
	 )
								;
	
	conversationtree=list_of
							(
							list_of
							 (
							  Conv(
								   "look around ",
								   "the room is large and spacious.  there is a table in the corner. ",
								   list_of
								   (
									Conv(
										 "examine table  ",
										 "there are many books on it, and a letter. ",
										 list_of
											(
												Conv(
													"look at books ",
													 "dusty old volumes; they've not been read in years. ",
													 noconv
													)
											)
											(
												Conv(
														"open envelope ",
														"you break the seal, and pull out the paper inside. ",
														list_of
														(
															Conv(
																"read letter",
																"it's a thank you note, from your sister. ",
																 noconv
															)
														)
													
													)
											)
										 )
									)
								   )
							  )
								   
								   (
										Conv(
												"go to window",
												"you walk to the window by the corner; the blinds are drawn. ",
												list_of
												(
													Conv(
														"pull back curtains",
														"you pull the curtains back; it is dark outside. ",
														 list_of
														(
															Conv(
																"close curtains ",
																 "you close the curtains again. ",														
																 noconv
															)
														 )
													)
												)
											)
									)
							)
	(
	 list_of
	
	  (
	  Conv(
		   "look around ",
		   "you find yourself in a bedroom. ",
		   list_of
		   (
			Conv (
				  "look at bed ",
				  "the duvet is on the floor. ",
				  list_of
				  (
				   Conv (
						 "make the bed ",
						 "you pull the sheets up, and put the duvet back over. ",
						 list_of
						 (
							Conv (
							"look at locker ",
							"there's a lamp on it, and it has a drawer. ",
								  list_of
								  (
									Conv (
								   "open drawer ",
										  "there is a diary in the drawer. ",
										  list_of
										  (
											Conv (
												"read the diary",
												"you've never read someone's diary before; you hesitate. ",
												  list_of
												  (
													Conv (
														"read the diary ",
														  "you open the book, and begin to read. ",
														  noconv
														  )
												  )
											)
										  )
								   
									)
								  )
							)
						 )
						 )
				   )
				  )
			)
		   (
			Conv (
				"leave",
				  "you...you don't feel inclined to leave. ",
				  noconv
			)
		   )
	  )
	 
	 )
	 )
	 
					
	;
}

void selectconversations()
{
	{
		list< list <string> >::iterator it=weatherdescriptions.begin();
		unsigned int i=rand()%weatherdescriptions.size();
		for (unsigned int j=0;j<i;j++)
			it++;
		selectedweather=*it;
	}
	
	{
		list< list <string> >::iterator it=traumadescriptions.begin();
		unsigned int i=rand()%traumadescriptions.size();
		for (unsigned int j=0;j<i;j++)
			it++;
		selectedtrauma=*it;
	}
	
	{
		list< list <Conv> >::iterator it=conversationtree.begin();
		unsigned int i=rand()%conversationtree.size();
		for (unsigned int j=0;j<i;j++)
			it++;
		selectedconv=*it;
	}
	
}

bool canselect(int i)
{
	return (i<selectedconv.size());
}